import 'dart:async';
import 'dart:ffi';
import 'dart:typed_data';
export 'package:unit_rc/UnitRC.dart';
import './UnitRCInit.dart';
import 'FuncDeclareDart.dart';
import 'ThreadUtils.dart';
import 'ThreadUtilsCppBridge.dart';

class ThreadUtilsCpp extends ThreadUtils with DartBaseProxyClass {
    // async: False, static: True
    static void runOnMainThread(void Function()? runnable) {
        var runnable_ffi = FuncDeclareDart.from_Void_Empty(runnable);
        _native_runOnMainThread(runnable_ffi);
    }
    static late final _native_runOnMainThread = lib.lookupFunction<
        Void Function(Handle),
        void Function(Object?)
    >("UnitRC_ThreadUtilsCpp_runOnMainThread");

    @override
    T? strongBaseRC<T extends DartBaseClass>() {
        return _native_strongRC(toCpp()) as T?;
    }
    static late final _native_strongRC = lib.lookupFunction<
        Handle Function(Pointer<Void>),
        Object? Function(Pointer<Void>)
    >("UnitRC_ThreadUtilsCpp_strongRC");

    @override
    WeakPtr<T> weakBaseRC<T extends DartBaseClass>() {
        final weak = _native_weakRC(toCpp()) as T?;
        return WeakPtr(ptr: weak);
    }
    static late final _native_weakRC = lib.lookupFunction<
        Handle Function(Pointer<Void>),
        Object? Function(Pointer<Void>)
    >("UnitRCTest_StrongWeakTestCpp_weakRC");

    static late final lib = _lib;
    static DynamicLibrary get _lib {
        final lib = UnitRCInit.lib;
        ThreadUtilsCppBridge.registerNativeMethods();
        return lib;
    }
}